/*
 *  untitled.mm
 *  ICExtensionMapping
 *
 *  Created by ostra on 2005.08.10.
 *  Copyright 2005 __MyCompanyName__. All rights reserved.
 *
 */

#import "CFile.h"
#import "CString.h"

void CURL::init() {
	m_ref = NULL;
}

void CURL::deleteRef() {
	if (m_ref != NULL)
		CFRelease(m_ref);
	m_ref = NULL;
}

CURL::CURL() {
	init();
}

CURL::CURL(CFURLRef relativeURL) {
	init();
	copyFromURL(relativeURL);
}

CURL::CURL(CFStringRef filePath, Boolean isDirectory) {
	init();
	copyFromString(filePath, isDirectory);
}

void CURL::copyFromURL(CFURLRef relativeURL) {
	deleteRef();
	if (relativeURL != NULL)
		m_ref = CFURLCopyAbsoluteURL(relativeURL);
}

void CURL::copyFromString(CFStringRef filePath, Boolean isDirectory) {
	m_ref = CFURLCreateWithFileSystemPath(kCFAllocatorDefault, filePath, kCFURLPOSIXPathStyle, isDirectory);
}

OSStatus CFSRef::makeByPath(const CString& path) {
	char buffer[512];
	path.copyToCSTR(buffer, 512);
	return FSPathMakeRef((const UInt8 *)buffer, &m_ref, NULL);
}

OSStatus CFSRef::getCatalogInfo(FSCatalogInfo *catalogInfo, HFSUniStr255 *outName, FSSpec *fsSpec, FSRef *parentRef) {
	return FSGetCatalogInfo(&m_ref, kFSCatInfoGettableInfo, catalogInfo, outName, fsSpec, parentRef); 
}

FSSpec CFSRef::getFSSpec() {
	FSCatalogInfo catalogInfo;
	FSSpec fsSpec;
	memset(&fsSpec, 0, sizeof(fsSpec));
	FSGetCatalogInfo(&m_ref, kFSCatInfoGettableInfo, &catalogInfo, NULL, &fsSpec, NULL); 
	return fsSpec;
}

void CReadStream::init() {
	m_ref = NULL;
}

void CReadStream::deleteRef() {
	if (m_ref != NULL)
		CFRelease(m_ref);
	m_ref = NULL;
}

void CResourceFile::init() {
	m_ref = 0;
}

Boolean CResourceFile::open(const FSSpec& spec, SignedByte permission) {
	m_ref = FSpOpenResFile(&spec, permission);
	return isNull() == false;
}

void CResourceFile::close() {
	if (m_ref != 0)
		CloseResFile(m_ref);
	m_ref = 0;
}

CResource CResourceFile::getResource(OSType sig, short id) {
	short saved = CurResFile();
	UseResFile(m_ref);
	CResource res;
	res.setHandle(Get1Resource(sig, id));
	UseResFile(saved);
	return res;
}

void *CResource::lock() {
	if (m_h == NULL)
		return NULL;
	HLock(m_h);
	return (void *)*m_h;
}

void CResource::unlock() {
	if (m_h == NULL)
		return;
	::HUnlock(m_h);
}
