/*
 *  TEntry.h
 *  ICExtensionMapping
 *
 *  Created by ostra on 2005.07.18.
 *  Copyright 2005 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef __TENTRY_H__
#define __TENTRY_H__

#import <Cocoa/Cocoa.h>
#import <Carbon/Carbon.h>
#import "CClass.h"

class TEntryMap;
class TEntry;

class TEntry {
public:
	ICMapEntry m_data;
	long m_pos;
	CString m_extension;
	CString m_fileCreator;
	CString m_fileType;
	CString m_creatorAppName;
	CString m_mimeType;
	CString m_entryName;
	CString m_postCreator;
	CString m_postAppName;
	Boolean m_dirty;
	int m_indexNumber;

	TEntry();
	void copyFrom(const TEntry &e);
	TEntry *clone();
	Boolean equals(const TEntry &e);
	Boolean operator==(const TEntry &e) {
		return equals(e);
	}
	Boolean operator!=(const TEntry &e) {
		return !equals(e);
	}
	void toData();
	void saveNewMapEntry(ICInstance ic, Handle mappingPrefHandle);
	void saveMapEntry(ICInstance ic, Handle mappingPrefHandle);
};

class TEntryArray : public CArray {
public:
	virtual void deleteItem(const void *item) {
		delete (TEntry *)item;
	}
};

class TEntryMap : public TEntryArray {
public:
	ICInstance m_ic;
	Handle m_mappingPrefHandle;
	TEntryArray m_deleted;

	Boolean attachIC();
	void detachIC();
	~TEntryMap();

	Boolean createEntryArray();
	TEntry *serarchResemble(const CString &extension, const CString &mimeType, const CString &fileCreator, const CString &fileType, TEntry *except);
	Boolean hasDirty();
	Boolean saveMapEntry();
	void onDelete(int i);

	class SortContext {
	public:
		CString m_field;
		Boolean m_ascending;
		SortContext() {
			m_field = "RS_EXTENSION";
			m_ascending = true;
		}
	};

	SortContext m_sortContext;
	static CFComparisonResult comparator(const void *val1, const void *val2, void *context);
};

#endif
